
' (C) 2007 i-TECH and Kristopher Windsor

Const ufile = 5000

Type file
  As String location
  As Integer depth, isfile
End Type

Dim Shared As file files(1 To ufile)
Dim Shared As Integer file_count

Sub file_reset
  file_count = 0
End Sub

Sub file_add (location As String, depth As Integer, isfile As Integer)
  If file_count < ufile Then
    file_count += 1
    With files(file_count)
      .location = location
      .depth = depth
      .isfile = isfile
    End With
  End If
End Sub

Sub file_list (path As String, depth As Integer = 1)
  Dim As Integer whichfolder, a, f = Freefile
  Dim As String folders(1 To 64), directory = path + "\", temp

  file_add(path, depth, 0)

  temp = Dir(directory + "*", 55): If temp = "" Then Exit Sub
  While Right(temp, 1) = "." Or Right(temp, 2) = "..": temp = Dir(""): Wend

  Do
    Open directory + temp For Input As #f
    If Err Then
      whichfolder += 1: folders(whichfolder) = directory + temp
    Else
      file_add(temp, depth + 1, -1)
      Close #f
    End If
    Do
      temp = Dir("")
    Loop Until Right(temp, 1) <> "." And Right(temp, 2) <> ".."
  Loop Until temp = ""

  For a = 1 To whichfolder
    file_list(folders(a), depth + 1)
  Next a
End Sub
