
' (C) 2007 i-TECH and Kristopher Windsor

#include once "itech\mylibs\iinput.bi"
#include once "itech\mylibs\imenu.bi"
#include once "itech\mylibs\keymouse.bi"

Const uhighscore = 12

Type highscore
  As Integer score
  As String player
End Type

Dim Shared As String highscore_filename
Dim Shared As highscore highscores(1 To uhighscore)

Sub highscore_start (Byref filename As String)
  highscore_filename = filename
  Open highscore_filename For Append As #1: Close #1
  Open highscore_filename For Input As #1
  For a As Integer = 1 To uhighscore
    If Eof(1) = false Then
      With highscores(a)
        Input #1, .score
        Line Input #1, .player
      End With
    End If
  Next a
  Close #1
End Sub

function highscore_add (Byref score As Integer) as integer
  Dim As Integer place

  If score <= highscores(uhighscore).score Then return false
  imenu "High Score!", "Okay"

  'find player rank
  For a As Integer = uhighscore To 1 Step -1
    If score > highscores(a).score Then place = a
  Next a

  'shift lower scores
  For a As Integer = uhighscore - 1 To place Step -1
    Swap highscores(a), highscores(a + 1)
  Next a

  With highscores(place)
    .score = score
    .player = iinput_line(12)
  End With

  return true
End function

Sub highscore_display
  Line universal_image, (0, 0) - (screen_size_x, screen_size_y), &HFF000000, bf
  Do
    Screenlock
    Put (0, 0), universal_image, alpha, 20
    font_display " High Scores ", font_center, 4,, true
    For a As Integer = 1 To uhighscore
      With highscores(a)
        font_display " " & .player & " [" & .score & "] ", font_center, a * 20 + 24,, true
      End With
    Next a
    Screenunlock

    Sleep 50
    updatemouse: updatekey
  Loop Until iskeymousing
End Sub

Sub highscore_finish
  Open highscore_filename For Output As #1
  For a As Integer = 1 To uhighscore
    With highscores(a)
      Print #1, .score
      Print #1, .player
    End With
  Next a
  Close #1
End Sub
