
' (C) 2007 i-TECH and Kristopher Windsor

#include once "windows.bi"
#include once "win/mmsystem.bi"

Const imci_standby = 0, imci_playing = 1

Dim Shared As Integer imci_mode
Dim Shared As Double imci_timer
Dim Shared As String imci_file

Declare Sub imci_stop

Sub imci_play (filename As String)
  imci_stop 'stops current audio
  If imci_mode = imci_standby Then
    'open audio file
    mciSendString("open """ + filename + """ type mpegvideo alias " + filename, NULL, 0, 0)
    'start playing
    mciSendString("play """ + filename + """ from 0", NULL, 0, 0)
    'set timer when audio starts
    imci_timer = Timer
    'set mode
    imci_file = filename
    imci_mode = imci_playing
  End If
End Sub

Sub imci_stop
  If imci_mode = imci_playing Then
    'close audio file
    mciSendString("close """ + imci_file + """", NULL, 0, 0)
    'set timer when audio stops
    imci_timer = Timer
    'set mode
    imci_mode = imci_standby
  End If
End Sub

Function imci_playtime As Double
  Return Timer - imci_timer
End Function

Function imci_repeat (seconds As Integer) As Integer
  Dim As Double t = Timer
  If imci_playtime >= seconds Then imci_play imci_file Else Return 0
  Return Timer - t
End Function

Sub imci_finish
  imci_stop
End Sub
