
' (C) 2007 i-TECH and Kristopher Windsor

Const key_escape = Chr(27), key_enter = Chr(13)

Dim Shared As Integer mx, my, mb, pmx, pmy, pmb, moffscreen
Dim Shared As String key

Sub updatekey
  key = Inkey
End Sub

Sub updatemouse
  pmx = mx: pmy = my: pmb = mb
  moffscreen = (Getmouse(mx, my,, mb) = 1)
  If moffscreen Then mx = pmx: my = pmy: mb = pmb
End Sub

Function iskeying As Integer
  Return key > "" And Instr(key_escape + key_enter + " ", key) > 0
End Function

Function iskeyescaping As Integer
  Return key = key_escape
End Function

Function iskeyupping As Integer
  Return key = Chr(255, 72)
End Function

Function iskeydowning As Integer
  Return key = Chr(255, 80)
End Function

Function iskeylefting As Integer
  Return key = Chr(255, 75)
End Function

Function iskeyrighting As Integer
  Return key = Chr(255, 77)
End Function

Function ismousing As Integer
  Return mb > 0 And pmb = 0
End Function

Function ismousemoving As Integer
  Return mx <> pmx Or my <> pmy
End Function

Function iskeymousing As Integer
  Return iskeying Or ismousing
End Function

Sub waitforinput
  Do
    updatemouse
    key = Inkey
  Loop Until iskeymousing
End Sub

Sub clearkeybuffer
  Do
    Sleep 25
    updatemouse
    key = Inkey
  Loop Until mb = 0 And key = ""
End Sub

Sub simulatemouse
  Select Case key
  Case Chr(255, 75)
    If mb >= 0 And mx - 40 >= 0 Then Setmouse mx - 40, my
  Case Chr(255, 77)
    If mb >= 0 And mx + 40 < screen_size_x Then Setmouse mx + 40, my
  Case Chr(255, 72)
    If mb >= 0 And my - 40 >= 0 Then Setmouse mx, my - 40
  Case Chr(255, 80)
    If mb >= 0 And my + 40 < screen_size_y Then Setmouse mx, my + 40
  Case Chr(13), " "
    mb = true
  End Select
End Sub
